net.sf.saxon.tree.iter

## Class ReverseArrayIterator<T extends Item>

- java.lang.Object
- - net.sf.saxon.tree.iter.ReverseArrayIterator<T>

- All Implemented Interfaces:
    LastPositionFinder<T>, SequenceIterator<T>, LookaheadIterator<T>, ReversibleIterator<T>, UnfailingIterator<T>

      public class ReverseArrayIterator<T extends Item>
      extends Object
      implements UnfailingIterator<T>, ReversibleIterator<T>, LookaheadIterator<T>, LastPositionFinder<T>

  ReverseArrayIterator is used to enumerate items held in an array in reverse order.
  Author:
    Michael H. Kay

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReverseArrayIterator(T[] items, int start, int end)` Create an iterator a slice of an array

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `T` | `current()` Get the current item in the sequence.
    `ReverseArrayIterator<T>` | `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence.
    `int` | `getLength()` Get the last position (that is, the number of items in the sequence).
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `SequenceIterator<T>` | `getReverseIterator()` Get an iterator that processes the same items in reverse order.
    `boolean` | `hasNext()` Determine whether there are more items to come.
    `T` | `next()` Get the next item in the sequence.
    `int` | `position()` Get the current position

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ReverseArrayIterator

          public ReverseArrayIterator(T[] items,
                              int start,
                              int end)

      Create an iterator a slice of an array
      Parameters:
        `items` - The array of items
        `start` - The first item in the array to be be used (this will be the last one in the resulting iteration). Zero-based.
        `end` - The item after the last one in the array to be used (this will be the first one to be returned by the iterator). Zero-based.

  - ### Method Detail

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.
      Specified by:
        `hasNext` in interface `LookaheadIterator<T extends Item>`
      Returns:
        true if there are more items in the sequence

    - #### next

          public T next()

      Description copied from interface: `UnfailingIterator`
      Get the next item in the sequence.
      Specified by:
        `next` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `next` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the next Item. If there are no more nodes, return null.

    - #### current

          public T current()

      Description copied from interface: `UnfailingIterator`
      Get the current item in the sequence.
      Specified by:
        `current` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `current` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the current item, that is, the item most recently returned by next()

    - #### position

          public int position()

      Description copied from interface: `UnfailingIterator`
      Get the current position
      Specified by:
        `position` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `position` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the position of the current item (the item most recently returned by next()), starting at 1 for the first node

    - #### getLength

          public int getLength()

      Description copied from interface: `LastPositionFinder`
      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder<T extends Item>`
      Returns:
        the number of items in the sequence

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator<T extends Item>`

    - #### getAnother

          public ReverseArrayIterator<T> getAnother()

      Description copied from interface: `UnfailingIterator`
      Get another iterator over the same sequence of items, positioned at the start of the sequence. It must be possible to call this method at any time, whether none, some, or all of the items in the original iterator have been read. The method is non-destructive: it does not change the state of the original iterator.
      Specified by:
        `getAnother` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `getAnother` in interface `UnfailingIterator<T extends Item>`
      Returns:
        a new iterator over the same sequence

    - #### getProperties

          public int getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator<T extends Item>`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

    - #### getReverseIterator

          public SequenceIterator<T> getReverseIterator()

      Get an iterator that processes the same items in reverse order. Since this iterator is processing the items backwards, this method returns an ArrayIterator that processes them forwards.
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator<T extends Item>`
      Returns:
        a new ArrayIterator

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.